## org.opencyc.elf.bg
Class BehaviorGeneration

    java.lang.Object
      |
      +--org.opencyc.elf.ELFObject
            |
            +--org.opencyc.elf.NodeComponent
                  |
                  +--org.opencyc.elf.bg.BehaviorGeneration

public class BehaviorGeneration
extends NodeComponent

Provides Behavior Generation for the Elementary Loop Functioning (ELF).

Author:
  Stephen L. Reed

  Copyright 2001 Cycorp, Inc., license is open source GNU LGPL.

  the license

  www.opencyc.org

  OpenCyc at SourceForge

  THIS SOFTWARE AND KNOWLEDGE BASE CONTENT ARE PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OPENCYC ORGANIZATION OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE AND KNOWLEDGE BASE CONTENT, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Field Summary
`protected java.util.ArrayList` `childrenBehaviorGeneration` the child nodes' BehaviorGeneration objects.
`protected Goal` `commandedGoal` the commanded goal for generated behavior to achieve
`protected BehaviorGeneration` `parentBehaviorGeneration` the parent node's BehaviorGeneration object.

Fields inherited from class org.opencyc.elf.NodeComponent
`DEFAULT_VERBOSITY, interruptionRequest, node, pendingInterruption, verbosity`

Fields inherited from class org.opencyc.elf.ELFObject
`name`

Constructor Summary
`BehaviorGeneration()` Constructs a new BehaviorGeneration object.

Method Summary
`java.util.ArrayList` `getChildrenBehaviorGeneration()` Gets the child nodes' BehaviorGeneration objects
`Goal` `getCommandedGoal()` Gets the goal for generated behavior to achieve
`BehaviorGeneration` `getParentBehaviorGeneration()` Gets the parent node's BehaviorGeneration object
`void` `setChildrenBehaviorGeneration(java.util.ArrayList childrenBehaviorGeneration)` Sets the child nodes' BehaviorGeneration objects
`void` `setCommandedGoal(Goal commandedGoal)` Sets the goal for generated behavior to achieve
`void` `setParentBehaviorGeneration(BehaviorGeneration parentBehaviorGeneration)` Sets the parent node's BehaviorGeneration object
`java.lang.String` `toString()` Returns a string representation of this object.

Methods inherited from class org.opencyc.elf.NodeComponent
`getNode, interrupt, setNode, setVerbosity`

Methods inherited from class org.opencyc.elf.ELFObject
`getName, setName`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### commandedGoal

    protected Goal commandedGoal

  the commanded goal for generated behavior to achieve

### parentBehaviorGeneration

    protected BehaviorGeneration parentBehaviorGeneration

  the parent node's BehaviorGeneration object. The topmost BehaviorGeneration object has a value null here.

### childrenBehaviorGeneration

    protected java.util.ArrayList childrenBehaviorGeneration

  the child nodes' BehaviorGeneration objects. The lowest level BehavoriGeneration object has a value null here.

Constructor Detail

### BehaviorGeneration

    public BehaviorGeneration()

  Constructs a new BehaviorGeneration object.

Method Detail

### toString

    public java.lang.String toString()

  Returns a string representation of this object.
  Overrides:
    `toString` in class `ELFObject`
  Returns:
    a string representation of this object

### getCommandedGoal

    public Goal getCommandedGoal()

  Gets the goal for generated behavior to achieve
  Returns:
    the goal for generated behavior to achieve

### setCommandedGoal

    public void setCommandedGoal(Goal commandedGoal)

  Sets the goal for generated behavior to achieve
  Parameters:
    `commandedGoal` - the goal for generated behavior to achieve

### getParentBehaviorGeneration

    public BehaviorGeneration getParentBehaviorGeneration()

  Gets the parent node's BehaviorGeneration object
  Returns:
    the parent node's BehaviorGeneration object

### setParentBehaviorGeneration

    public void setParentBehaviorGeneration(BehaviorGeneration parentBehaviorGeneration)

  Sets the parent node's BehaviorGeneration object
  Parameters:
    `parentBehaviorGeneration` - the parent node's BehaviorGeneration object

### getChildrenBehaviorGeneration

    public java.util.ArrayList getChildrenBehaviorGeneration()

  Gets the child nodes' BehaviorGeneration objects
  Returns:
    the child nodes' BehaviorGeneration objects

### setChildrenBehaviorGeneration

    public void setChildrenBehaviorGeneration(java.util.ArrayList childrenBehaviorGeneration)

  Sets the child nodes' BehaviorGeneration objects
  Parameters:
    `childrenBehaviorGeneration` - the child nodes' BehaviorGeneration objects